# -*- coding: utf-8 -*-
###########################################################################################################
#   Universidad de la República, Facultad de Ingeniería, Instituto de Ingeniería Eléctrica 
#
#   Copyright 2017 Universidad de la República, Facultad de Ingeniería, Instituto de Ingeniería Eléctrica 
#
#   Autores: Pablo Pérez-Nicoli, Francisco Veirano, Juan Pablo Oliver
#
#   Version: 1.0
#
#   This file is part of HTERM 3.0.
#
#   HTERM 3.0 is free software: you can redistribute it and/or modify it under the terms of the GNU 
#	 General Public License as published by the Free Software Foundation, either #version 3 of the 
#   License, or (at your option) any later version.
#
#   HTERM 3.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
#   even the implied warranty ofMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along with HTERM 3.0. 
#   If not, see <http://www.gnu.org/licenses/>.
###########################################################################################################
from  PyQt4.QtGui import QDialog
from  PyQt4.QtGui import QVBoxLayout
from  PyQt4.QtGui import QLabel
from  PyQt4.QtGui import QPixmap
from  PyQt4.QtCore import Qt
from  PyQt4.QtGui import QPalette
import webbrowser

class acercade():
    def __init__(self, mainWind):
            self.mainWind=mainWind #Da acceso a todos los objetos
            #Se conectan las funciones y los eventos de interfaz
            self.mainWind.acerca_de.triggered.connect(self.aboutApp) #La funcion aboutApp de esta clase se ejecuta al hacer click en Acerca de, del menu ayuda.  
            self.mainWind.ayuda.triggered.connect(self.ayuda) #La funcion ayuda de esta clase se ejecuta al hacer click en Ayuda, del menu ayuda.  
            self.mainWind.mapa.triggered.connect(self.mapa) #La funcion mapa de esta clase se ejecuta al hacer click en Mapas zonas climaticas, del menu ayuda.  
    
    def ayuda(self):   
            #Funcion que carga el pdf de ayuda que fue armado por el grupo de arquitectos.
            securitySearchForm = self.mainWind.resource_path(r"Ayuda_Hterm_3_0.pdf") #La funcion resource_path es para q el codigo encuentre el archivo aun cuando el mismo fue embebido
            webbrowser.open_new(securitySearchForm) #Se abre el pdf con el lector de pdf por defecto de la PC. Notar que si la PC no tiene lector de PDF esto no va a ser capaz de abrir el documento
            
    def aboutApp(self):
            #Funcion que muestra los creditos del programa
            self.dialog = QDialog() #Se crea el windows
            self.dialog.setWindowTitle("Acerca de") #se le carga el titulo
            #Se le impone un fondo blanco a la ventana al igual que la imagen que diseño el mimisterio para presentar los creditos.            
            palette = QPalette() 
            palette.setColor(QPalette.Background, Qt.white)
            self.dialog.setPalette(palette)
            #Se carga la imagen          
            layout = QVBoxLayout()
            imageLabel = QLabel()
            securitySearchForm = self.mainWind.resource_path("creditos-hterm3-2.jpg") #La funcion resource_path es para q el codigo encuentre el archivo aun cuando el mismo fue embebido                
            pixmap = QPixmap(securitySearchForm)
            imageLabel.setPixmap(pixmap)
            layout.addWidget(imageLabel)
            self.dialog.setLayout(layout)
            self.dialog.show()
            
    def mapa(self):
            #Funcion que abre una ventana para mostrar el mapa de las zonas climaticas que proporcionó El grupo de arquitectos
            #El codigo es muy similar al aboutApp
            self.dialog = QDialog()
            self.dialog.setWindowTitle(u'Mapa Zonas Climáticas')
            palette = QPalette()
            palette.setColor(QPalette.Background, Qt.white)
            self.dialog.setPalette(palette)
            #Se carga la imagen     
            layout = QVBoxLayout()
            imageLabel = QLabel()
            securitySearchForm = self.mainWind.resource_path("mapa_uy_zonas.jpg")                   
            pixmap = QPixmap(securitySearchForm)
            imageLabel.setPixmap(pixmap)
            layout.addWidget(imageLabel)
            self.dialog.setLayout(layout)
            self.dialog.show()        
