# -*- coding: utf-8 -*-
###########################################################################################################
#   Universidad de la República, Facultad de Ingeniería, Instituto de Ingeniería Eléctrica 
#
#   Copyright 2017 Universidad de la República, Facultad de Ingeniería, Instituto de Ingeniería Eléctrica 
#
#   Autores: Pablo Pérez-Nicoli, Francisco Veirano, Juan Pablo Oliver
#
#   Version: 1.0
#
#   This file is part of HTERM 3.0.
#
#   HTERM 3.0 is free software: you can redistribute it and/or modify it under the terms of the GNU 
#	 General Public License as published by the Free Software Foundation, either #version 3 of the 
#   License, or (at your option) any later version.
#
#   HTERM 3.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
#   even the implied warranty ofMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along with HTERM 3.0. 
#   If not, see <http://www.gnu.org/licenses/>.
###########################################################################################################

from PyQt4.uic import loadUiType
from PyQt4.QtGui import QIcon
from os import path as ph
import sys

from PyQt4.QtGui import QMessageBox
from PyQt4.QtGui import QPushButton

def resource_path(relative_path):
    """ Get absolute path to resource, works for dev and for PyInstaller """
    try:
        # PyInstaller creates a temp folder and stores path in _MEIPASS
        base_path = sys._MEIPASS
    except Exception:
        base_path = ph.abspath(".")

    return ph.join(base_path, relative_path)

securitySearchForm = resource_path("conversor.ui")
Ui_conv, Qconv = loadUiType(securitySearchForm)

icon = resource_path("hterm.ico")

class conversor(Qconv, Ui_conv):
    def __init__(self,mainWind):
            super(conversor, self).__init__()
            self.setupUi(self)                      # configuro ventana del conversor
            self.mainWind=mainWind
            # conecto el menu de la mainwindow correspondiente al conversor con el show de esta interfaz 
            mainWind.conv_uni.triggered.connect(self.abrirConversor)  
            # conecto una activación del combo de unidades disponibles con la funcion que calcula
            self.unidadesCombo.activated.connect(self.calcularUnidad)
            # conecto un cambio en los text box con la funcion que realiza el calaculo
            self.valorEntrada.textChanged.connect(self.calcularUnidad)
            # sete el icono de la nueva ventana
            self.setWindowIcon(QIcon(icon))

    def abrirConversor(self):
    # Función encargada de abrir la ventana del conversor.     
      self.show()
        
    def calcularUnidad(self):
    # Funcion que realiza la conversion de unidades    
        # Me fijo cual de las unidades del combo estan
        index=self.unidadesCombo.currentIndex() 
        
        try: 
            # trato de pasar a float y si no puedo, doy el mensaje de error correspondiente    
            valor = float(self.valorEntrada.text())     
            if index == 0:
                     salida = valor/2.0835e-9   
                     self.valorSalida.setText("%.4E" % salida)
            elif index== 1:
                     salida = valor/1e8
                     self.valorSalida.setText("%.4E" % salida)
            elif index==2: 
                     salida = valor/0.86813e-12 
                     self.valorSalida.setText("%.4E" % salida)
            else: 
                     salida = valor/1.453e-12 
                     self.valorSalida.setText("%.4E" % salida)
        except ValueError:
            #Si no puedo hacer la conversion es porque la persona puso cualquier cosa.
            #En ese caso, llama a la funcion errorParametroInvalido y le paso el nombre del parametro y el valor incorrecto
            self.errorParametroInvalido(u'El valor de entrada debe ser númerico.')

   

    def errorParametroInvalido(self,textodetallado):
        #Funcion que se ejecuta para avisarle al usuario que "valorIncorrecto" en "parametro" no es valido
        msg = QMessageBox() #genero la ventana
        msg.setWindowTitle(u'Error')
        msg.setIcon(QMessageBox.Warning) #le pongo el signo de warning (puedo poner alerta y pregunta)
        msg.setText(textodetallado) # mensaje principal del error    
        msg.addButton(QPushButton('Aceptar'), QMessageBox.AcceptRole)
        
        msg.exec_() # No se bien que hace pero es necesario   
