# -*- coding: utf-8 -*-
###########################################################################################################
#   Universidad de la República, Facultad de Ingeniería, Instituto de Ingeniería Eléctrica 
#
#   Copyright 2017 Universidad de la República, Facultad de Ingeniería, Instituto de Ingeniería Eléctrica 
#
#   Autores: Pablo Pérez-Nicoli, Francisco Veirano, Juan Pablo Oliver
#
#   Version: 1.0
#
#   This file is part of HTERM 3.0.
#
#   HTERM 3.0 is free software: you can redistribute it and/or modify it under the terms of the GNU 
#	 General Public License as published by the Free Software Foundation, either #version 3 of the 
#   License, or (at your option) any later version.
#
#   HTERM 3.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
#   even the implied warranty ofMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along with HTERM 3.0. 
#   If not, see <http://www.gnu.org/licenses/>.
###########################################################################################################
from numpy import isnan
from pickle import load
from pickle import dump  
from PyQt4.QtGui import QFileDialog
from PyQt4.QtGui import QMessageBox
from PyQt4.QtGui import QPushButton
from PyQt4.QtGui import QTableWidgetItem
from PyQt4.QtGui import QFont
from PyQt4.QtGui import QColor
from PyQt4.QtGui import QStyledItemDelegate
from PyQt4.QtGui import QItemEditorFactory
from PyQt4.QtGui import QLineEdit
from PyQt4.QtCore import Qt
from PyQt4.QtCore import QVariant
from PyQt4.QtGui import QItemEditorCreatorBase
from os import getcwd

import TableWidgetDragRows as TableWidgetDragRows  #Esta clase sobre define QTableWidget para lograr que funcione el dropOn

#Estas dos primeras clases son para settear la forma en que se muestran y editan los datos de la tabla.
class DateTimeEditorCreator(QItemEditorCreatorBase):
    def __init__(self):
        QItemEditorCreatorBase.__init__(self)
        
    def createWidget(self, parent):
        wid = QLineEdit(parent)
        return wid

class DateFormatDelegate(QStyledItemDelegate):
    def __init__(self, mainWind):
        QStyledItemDelegate.__init__(self)        
        self.mainWind=mainWind

    def displayText(self, value, locale):
        return self.mainWind.generador_muro_obj.formato_numeros(value)

class generador_muro():
############ FUNCION INICIO ############ 
    def __init__(self, mainWind): # Esta fuencion se ejecuta siempre que se instancia la clase
        #### Defino e inicializo varibles de la clase ####
        self.mainWind=mainWind #esta es la ventana principal, me permite acceder a todo lo visible
        self.columnas_a_mostrar_muro_from_preview = range(2,self.mainWind.material_preview.columnCount()) #muestro todas las del preview salvo las primeras dos
        self.hubicacion_columnas_a_mostrar_muro_from_preview = range(0,len(self.columnas_a_mostrar_muro_from_preview)+0) #pocicion relativa de las columnas del preview en el muro. Por ahora quedaron en el mismo lugar.
        self.parametros_ordenados_de_tabla = [1,2,3,4,6,8,11,9,12,5,7,10] #e,ro,M,lamda,R,ro,mu,z,sd,cp. numero las columnas del muro en la interfaz de estos parametros en este orden. Esto es para tener un order simple para nosotros (el escrito en este comentario) y mantener la distribucion que solicitan los arquitectos en el software.
        self.capas_malas = [] #Aca se cargan los indices de todas las capas que no tienen un dato que se pueda convertir a float. Ya sea porque le falta el dato o porque el mismo no es valido (no tiene cast a float). Esto no lo verifico para todos los parametros, solo para los impresindibles en el calculo
        self.camara_MV=[] #Aca se guardan todos los indices que tienen camaras de aire muy ventiladas
        self.camara_NMV=[] #Aca se guardan todas las capas donde hay camaras de aire no muy ventiladas
        self.datos_muro_lista = 0 #Aca se guardan los datos cono lista de listas, esta variable es utilizada por el resto del programa para hacer los calculos correspondientes. Se guardan en el mismo orden que se ven en la interface.
        self.muro_valido=False #bandera que indica si un muro es valido o no.
        self.archivo_muro_trabajando= None #archivo .muro en el que estoy trabajando.
        self.muro_actual_guardado = False #Bandera que indica si el muro actual ya fue guardado o no
        #### Inicializo componentes ####
        self.inicializo_muro_armado() #Inicializo el TableWidget muro_armado
                
        #### Conecto componentes con funciones ####
        self.mainWind.muro_armado.itemChanged.connect(self.muro_modificado)  #se ejecuta cuando cualquier cosa del muro cambia     
        self.mainWind.agregar_capa.clicked.connect(self.agregar_capa_clicked) #se ejecuta cuando se apreta el boton agregar capa
        self.mainWind.sustituir_capa.clicked.connect(self.sustituir_capa_clicked) #se ejecuta cuando se apreta el boton sustituir capa
        self.mainWind.borrar_capa.clicked.connect(self.borrar_capa_clicked) #se ejecuta cuando se apreta el boton borrar capa
        self.mainWind.cargar_muro.triggered.connect(self.cargar_muro_triggered)#se ejecuta cuando se apreta el boton cargar cerramiento del menu archivo
        self.mainWind.guardar_muro.triggered.connect(self.guardar_muro_triggered)#se ejecuta cuando se apreta el boton guardar cerramiento del menu archivo
        self.mainWind.guardar_muro_como.triggered.connect(self.guardar_muro_como_triggered)#se ejecuta cuando se apreta el boton guardar cerramiento como del menu archivo
        self.mainWind.nuevo_cerramiento.triggered.connect(self.nuevo_cerramiento_triggered)#se ejecuta cuando se apreta el boton nuevo cerramiento del menu archivo
        
############ FUNCIONES INICIALIZACION Y REFRESCO ############    
    
    def inicializo_muro_armado(self):   
        self.mainWind.muro_armado = TableWidgetDragRows.TableWidgetDragRows() #genero la tabla tablewidget que permite hacer drag drop
        self.mainWind.layout_muro_armado.addWidget(self.mainWind.muro_armado) #inserto la tabla que defini en la linea anterior en el layout que se define en el archivo .ui hecho con pyQT
        self.mainWind.muro_armado.setSortingEnabled(False) #deshabilito para que la lista no pueda ordenar por valores segun sus parametros. Ya que no tiene sentido en esta app
        #Cargo los nombres de columnas de las tablas e inicializo su tamaño.
        #Primero Para tabla Muro
        cantidad_de_columnas=len(self.columnas_a_mostrar_muro_from_preview)+1
        self.mainWind.muro_armado.setColumnCount(cantidad_de_columnas)#mas uno porque agrego al final una (observaciones) 
        self.mainWind.muro_armado.setRowCount(0) #el muro arranca sin capas
        horHeaders = [] #variable auxiliar para cargar el texto que se muestra en cada columna
        for j in self.columnas_a_mostrar_muro_from_preview:#menos uno porque aca no voy a cargar todas las columnas, observaciones la cargo al final
            if j==2:
                horHeaders.append('Nombre \n (comenzar por capa interior)' ) #para cada columna que quiero mostrar cargo el texto segun aparece en el preview, el mas dos es porque me salteo las dos primeras de tipo y subtipo
            else:
                horHeaders.append(self.mainWind.material_preview.horizontalHeaderItem(j).text()) #para cada columna que quiero mostrar cargo el texto segun aparece en el preview, el mas dos es porque me salteo las dos primeras de tipo y subtipo
        #horHeaders.append(u'OBSERVACIÓN')    
        horHeaders.append(u'OBS')    
        self.mainWind.muro_armado.setHorizontalHeaderLabels(horHeaders) #aca efectivamente pongo en su lugar los titulos de las columnas
        self.mainWind.muro_armado.resizeColumnsToContents() #ajusto para que el ancho este acorde al nombre de la columna
        self.mainWind.muro_armado.show() #muestro la tabla (no se si es realmente necesario)
        #Esto hace que al posar el cursor sobre los header de la tabla donde se arma el muro, aparecen estos tips al costado el cursor.
        self.mainWind.muro_armado.horizontalHeaderItem(1).setToolTip(u"Espesor")
        self.mainWind.muro_armado.horizontalHeaderItem(2).setToolTip(u"Densidad")
        self.mainWind.muro_armado.horizontalHeaderItem(3).setToolTip(u"Masa")
        self.mainWind.muro_armado.horizontalHeaderItem(4).setToolTip(u"Conductividad térmica")
        self.mainWind.muro_armado.horizontalHeaderItem(5).setToolTip(u"Calor específico")
        self.mainWind.muro_armado.horizontalHeaderItem(6).setToolTip(u"Resistencia térmica")
        self.mainWind.muro_armado.horizontalHeaderItem(7).setToolTip(u"Capacidad térmica media")
        self.mainWind.muro_armado.horizontalHeaderItem(8).setToolTip(u"Permeabilidad al vapor agua")
        self.mainWind.muro_armado.horizontalHeaderItem(9).setToolTip(u"Resistencia al vapor de agua")
        self.mainWind.muro_armado.horizontalHeaderItem(10).setToolTip(u"Permeancia al vapor de agua")
        self.mainWind.muro_armado.horizontalHeaderItem(11).setToolTip(u"Factor de resistencia al vapor de agua")
        self.mainWind.muro_armado.horizontalHeaderItem(12).setToolTip(u"Espesor de aire equivalente SD")
        self.mainWind.muro_armado.horizontalHeaderItem(13).setToolTip(u"Observación")
        self.mainWind.muro_armado.horizontalHeader().setStretchLastSection(True) #Para que el ancho de las columnas se ajuste al ancho de la ventana        
        #Para lograr que los datos se muestren de una manera truncada tipo eng, sin necesidad de truncar su valor, se define lo siguiente
        factory = QItemEditorFactory()
        formato=DateFormatDelegate(self.mainWind)
        formato.setItemEditorFactory(factory)
        self.mainWind.muro_armado.setItemDelegate(formato)
        self.mainWind.muro_armado.itemDelegate().setItemEditorFactory(factory)
        self.mainWind.muro_armado.itemDelegate().itemEditorFactory().registerEditor(QVariant.String, DateTimeEditorCreator())
        self.mainWind.muro_armado.itemDelegate().itemEditorFactory().registerEditor(QVariant.Double, DateTimeEditorCreator())
        
############ FUNCIONES DIRECTAMENTE ASOCIADAS A COMPONENTES ############ 
    
    def muro_modificado(self, item_modificado):   
        #Funcion que se ejecuta ante cualquier modificacion en el TableWidget muro_armado
        #Cuando en el item_modificado tengo 0 es porque no se modifico uno en particular sino mas de una cosa. Ya sea porque se cargó un muro nuevo, porque se agregó una capa o porque se borro una capa
        self.mainWind.muestroDatosObj.clearFig() #Borro la figura, para que no sea incoherente los datos del muro y lo que muesrta la figura
        if not(self.archivo_muro_trabajando==None):#si ya estoy trabajando en algun archivo .muro (si ya fue guardado alguna vez):
            self.mainWind.changeTitle(self.archivo_muro_trabajando + '*') #al modificar el muro tengo que agregar un * para indicar que el muro se modifico y que aun no fue guardado (al guardarlo le saco el *)
        self.muro_actual_guardado = False #Indico que el muro fue modificado y NO guardado
        self.mainWind.muro_armado.blockSignals(True) #para asegurarme que no entro en loop, todas las modificaciones que haga esta funcion en el muro no van a volver a llamarla
        #Primero autocompleto lo que falte y pueda hacerlo
        self.autofill_de_muro(item_modificado)
        #Luego pinto el muro, verificando si es valido. Aca se que si me faltan parametros, q no los completo el autofill, es porque no estan y no se puede calcular. asi que la capa es invalida
        self.pinto_muro()
        #Por utlimo guardo en la variable self.datos_muro_lista. Notar que esta variable puede tener errores, pero es la que voy a guardar cuando guarde el muro y devolver si alguien me pregunta que tengo en el muro
        #notar que la variable self.datos_muro_lista SOLO se genera aca
        filas = self.mainWind.muro_armado.rowCount() #cantidad de filas en la planilla
        columnas= self.mainWind.muro_armado.columnCount() #cantidad de columnas en la planilla
        self.datos_muro_lista = [[0 for x in range(columnas)] for y in range(filas)] #genero la lista de listas Datos_muro con el tamano indicado         
        for j in range(columnas):
            for i in range(filas):
                try:
                    self.datos_muro_lista[i][j]= self.mainWind.muro_armado.item(i,j).text()
                except:
                    self.datos_muro_lista[i][j]= u''
        self.mainWind.muro_armado.resizeColumnsToContents()#ajusto el ancho de las columnas a su contenido
        self.mainWind.muro_armado.blockSignals(False)#vuelvo a habilitar la señal para que cualquier proxima modificacion en el muro ejecute efectivamente esta funcion.
        self.mainWind.muro_armado.horizontalHeader().setStretchLastSection(True) #Para que el ancho de las columnas se ajuste al ancho de la ventana
        
    def agregar_capa_clicked(self):   
        #Funcion asociada a el click en el PushBotton agregar_capa
        cantidad_capas=self.mainWind.muro_armado.rowCount()+1 #porque estoy agregando una
        self.mainWind.muro_armado.setRowCount(cantidad_capas) #aumento la cantidad de filas de la tabla muro
        self.poner_capa(cantidad_capas-1)   #llamo a la funcion poner capa que inserta lo que esta en capa nueva en la ultima fila. (el menos uno es porque se cuenta desde cero)
        
    def sustituir_capa_clicked(self):   
        #Funcion asociada a el click en el PushBotton sustituir_capa
        if not self.mainWind.muro_armado.selectedIndexes()==[]: #si hay algo seleccionado     
            row_a_editar = self.mainWind.muro_armado.selectedIndexes()[1].row() #pregunto que fila esta seleccionada
            self.poner_capa(row_a_editar) #llamo a la funcion que carga todo lo que este en la tabla capa nueva y le paso como parametro donde tiene que meter esa capa nueva

    def borrar_capa_clicked(self):   
        #Funcion asociada a el click en el PushBotton borrar_capa
        #Se ejecuta cuando hago click en el boton borrar capa
        if not self.mainWind.muro_armado.selectedIndexes()==[]: #pregunto si hay o no algo seleccionado        
            #si efectivamente hay algo            
            row_a_borrar = self.mainWind.muro_armado.selectedIndexes()[1].row() #pregunto que fila es la seleccionada
            self.mainWind.muro_armado.removeRow(row_a_borrar) #borro la fila seleccioanda
            self.muro_modificado(None) # corro la funcion muro_modificado, para que actualice la variable datos_muro. Esta es la unica accion que donde QT no considera que la tabla fue modificada por eso corro la funcion "a mano" digamos

    def cargar_muro_triggered(self):   
        #Funcion asociada a el trigger en el PushBotton MenuBar button cargar_muro
        self.mainWind.muro_armado.blockSignals(True) #como voy a modificar mucho el muro, bloqueo la funcion que se ejecuta cada vez que se modifica el muro.
        cwd=getcwd() #get current working directory
        dialogo = QFileDialog() #Genero el dialogo para q el usuario seleccione el archivo .muro a cargar
        dialogo.setWindowTitle('Cargar Cerramiento') #le modifico el titulo
        dialogo.setDirectory(cwd) #El dialogo arranca mostrando el direcctorio donde esta la aplicacion.
        dialogo.setAcceptMode(QFileDialog.AcceptOpen) 
        dialogo.setNameFilter('Cerramiento (*.muro)')#solo se dejan seleccionar archivos .muro
        dialogo.setDefaultSuffix('muro') 
        if dialogo.exec_() == QFileDialog.Accepted:
            fname=dialogo.selectedFiles()[0] #En caso que el usuario acepte el archivo se carga en fname
        else:
            fname=u'' #si cierra o cancela la ventana de dialogo, entonces no saco nombre y no hago mas nada
        if not fname==u'': #si la persona cancela, el nombre del archivo va a ser vacio.
            try:            
                archivo = open(fname, 'r') #abro el archivo que la persona selecciono
                muro_cargado=load(archivo) #uso pickle para cargar el archivo ya que el mismo fue generado con la misma herramienta 
                archivo.close() #cierro el archivo
                #Cargo todo los dados en la tabla
                filas = len(muro_cargado) #el largo es la cantidad de capas
                if not filas==0: #puede pasar que la persona haya guardado un muro sin capas.
                    columnas = len(muro_cargado[0]) #Todas las capas tienen la misma cantidad de propiedades (columnas) por como es el programa. Asi que de la primer capa saco esa cantidad. Podria usar para esto len(columna_a_mostrar)+1 (para sumarle "nombre"). Es lo mismo
                    self.mainWind.muro_armado.setRowCount(filas) #seteo la cantidad de filas
                    for i in range(filas): 
                        for j in range(columnas):
                            #para cada celda
                            newitem = QTableWidgetItem(unicode(muro_cargado[i][j]))
                            self.mainWind.muro_armado.setItem (i, j, newitem)#cargo el item nuevo
                else:
                    self.mainWind.muro_armado.setRowCount(0)
                    self.muro_modificado(None)
                self.mainWind.muestroDatosObj.actualizoDatos()#llamo al a funcion que grafica  
                self.muro_modificado(None) #ejecuto muro modificado, para actualizar la self.datos_muro_lista ajustar ancho de columnas etc, pero no hago auto fill de nada
                self.archivo_muro_trabajando=fname #dejo cuardado el nombre y ruta del archivo .muro donde estoy trabajando
                self.mainWind.changeTitle(fname) #inserto el nombre del archivo con la funcion changeTitle (Funcion del main que le da ademas formato a lo que se pone en el titulo del windows.)
            except:
                msg = QMessageBox() #gerero la ventana
                msg.setIcon(QMessageBox.Warning) #le pongo el signo de warning (puedo poner alerta y pregunta)
                msg.setWindowTitle('Error')
                msg.setText(u'El archivo que intenta cargar está dañado.') # mensaje principal del error
                msg.addButton(QPushButton('Aceptar'), QMessageBox.AcceptRole)                
                retval = msg.exec_() # Abro la ventana
        self.mainWind.muro_armado.blockSignals(False)#habilito para que futuras modificaciones del muro ejecuten la funcion muro modificado
        
    def borrar_cerramiento_completo(self):   
        self.mainWind.muro_armado.setRowCount(0)
        self.muro_modificado(None)
        
    def nuevo_cerramiento_triggered(self):   
        if (self.muro_actual_guardado==False):
            msg = QMessageBox() #gerero la ventana
            msg.setIcon(QMessageBox.Question) #le pongo el signo de warning (puedo poner alerta y pregunta)
            msg.setText(u'Desea guardar el cerramiento actual.') # mensaje principal del error
            botoncancelar=msg.addButton(QMessageBox.Cancel)#Agregamos boton de cancelar
            botoncancelar.setText('Cancelar')
            botonno=msg.addButton(QMessageBox.No)#Agregamos boton de no
            botonsi=msg.addButton(QMessageBox.Yes)#Agregamos boton de si
            msg.setWindowTitle(u'Mensaje')
            retval = msg.exec_() # Abro la ventana
            if msg.clickedButton()==botonsi: #si se apreta "si"
                self.guardar_muro_triggered() #llamo a la misma fucion que se ejecuta cuando se apreta en guardar muro
                self.archivo_muro_trabajando=None #como el usuario pidio un nuevo muro, borro el archivo muro trabajando, ahora no se esta trabajando en ningun muro (hasta que se guarde)
                self.borrar_cerramiento_completo() #se borra el cerramiento actual 
                self.mainWind.changeTitle('Sin nombre *') #funcion de main que ajusta el titulo del main windows
            if msg.clickedButton()==botonno: #si se apreta "no"
                self.archivo_muro_trabajando=None #Casi igual al caso de si, pero sin guardar el cerramiento actual
                self.borrar_cerramiento_completo() #se borra el cerramiento actual 
                self.mainWind.changeTitle('Sin nombre *') #funcion de main que ajusta el titulo del main windows
        else:
            #idem caso, usuario selecciona No guardar, ya que esto se ejecuta en el caso que el muro ya estaba guardado
            self.archivo_muro_trabajando=None 
            self.borrar_cerramiento_completo()
            self.mainWind.changeTitle('Sin nombre *')
            
    def guardar_muro_triggered(self):   
        #Funcion asociada a el trigger en el PushBotton MenuBar button guardar_muro
        if not(self.archivo_muro_trabajando==None): #si ya se habia guardado antes, ya se conoce el destino del muro (donde se debe guardar)
            self.muro_modificado(None)  #es necesario actualizar el muro antes, porque si movieron alguna fila no queda bien actualizado.              
            self.mainWind.muestroDatosObj.actualizoDatos() #es necesqario graficar de nuevo porque la funcion muro_modificado lo borra    
            archivo = open('%s' % self.archivo_muro_trabajando, 'w')#abro archivo
            dump(self.datos_muro_lista, archivo) #uso la herramienta pickle para guardar la variable Datos_muro en el archivo previamente seleccionado
            archivo.close() #cierro el archivo
            self.mainWind.changeTitle(self.archivo_muro_trabajando)#funcion de main que ajusta el titulo del main windows
            self.muro_actual_guardado=True #indico que el muro actual fue guardado
        else: #si es la primera vez que se va a guardar, el comportamiento es identico al de "guardar cerramiento como"
            self.guardar_muro_como_triggered() 
        
    def guardar_muro_como_triggered(self):   
        #Funcion asociada a el trigger en el PushBotton MenuBar button guardar_muro_como
        self.muro_modificado(None)  #es necesario actualizar el muro antes, porque si movieron alguna fila no queda bien actualizado.              
        self.mainWind.muestroDatosObj.actualizoDatos() #es necesqario graficar de nuevo porque la funcion muro_modificado lo borra    
        cwd=getcwd() #obtengo el current working directory
        dialogo = QFileDialog() #Abro dialogo para seleccionar el nombre y lugar donde se guardara el cerramiento
        dialogo.setWindowTitle('Guardar Cerramiento') #titulo de la ventana 
        dialogo.setDirectory(cwd) #Se abre mostrando el directorio donde estoy trabajando
        dialogo.setAcceptMode(QFileDialog.AcceptSave)
        dialogo.setNameFilter('Cerramiento (*.muro)') #solo muestra archivos con la extension .muro
        dialogo.setDefaultSuffix('muro') #si el usuario no pone la extension del archivo, el programa lo impone.
        if dialogo.exec_() == QFileDialog.Accepted:
            fname=dialogo.selectedFiles()[0] #si efectivamente se selecciona un destino este se guarda en fname
        else:
            fname=u'' #si se cancela, en fname se pone el unicode vacio.
        if not fname==u'': #si la persona cancela el nombre va a estar vacio
            archivo = open('%s' % fname, 'w') #creo el archivo en el lugar y con el nombre indicado por el usuario
            dump(self.datos_muro_lista, archivo) #uso la herramienta pickle para guardar la variable Datos_muro en el archivo previamente seleccionado
            archivo.close() #cierro el archivo
            self.archivo_muro_trabajando=fname #guardo en la variable de clase el nombre del muro donde estoy trabajando
            self.mainWind.changeTitle(self.archivo_muro_trabajando) #funcion del main que actualiza el nombre del main windows
            self.muro_actual_guardado=True #indico que el muro actual fue guardado
            
############ FUNCIONES AUXILIARES ############ 
    
    def poner_capa(self, row_a_editar):
        #funcion que carga todo lo que esta en capa nueva en la tabla de muro
        self.mainWind.muro_armado.blockSignals(True)#para que no se este llamando cada vez bloqueo a muro_armado. De esta forma no se esta llamando cada vez a muro modificado
        cantidad_columnas_a_cargar = len(self.columnas_a_mostrar_muro_from_preview)
        for j in range(cantidad_columnas_a_cargar):
            #para cada columna pongo en la fila y columna correspondiente del muro lo que estaba en capa nueva
            aux=self.mainWind.material_preview.item(0,self.columnas_a_mostrar_muro_from_preview[j]).text()
            aux=self.formato_numeros(aux)
            dato = QTableWidgetItem(aux)
            self.mainWind.muro_armado.setItem(row_a_editar, self.hubicacion_columnas_a_mostrar_muro_from_preview[j], dato)
        self.mainWind.muro_armado.blockSignals(False) #vuelvo a habilitar a muro armado
        self.muro_modificado(row_a_editar) #ahora si llama a la funcion muro modificado, se le pasa como parametro la fila que se modifico para que solo haga autofill en esa fila.
        
    def autofill_de_muro(self,item_modificado):
        #funcion que autocompleta solo en caso que haya algo que autocompletar.
        #Autofill recibe item_modificado=integer si se modifico una capa, y el item modificado (un QtableWidgetItem) en otro caso. Puede recibir None si no se desea hacer autofill de nada.
        filas = self.mainWind.muro_armado.rowCount() #cantidad de filas en la planilla
        columnas= self.mainWind.muro_armado.columnCount() #cantidad de columnas en la planilla
        if type(item_modificado)==type(QTableWidgetItem()):#Esto pasa es porque lo que se modifico es un solo item.
            i= item_modificado.row()
            j= item_modificado.column()
            self.autofill_celda_particular(i,j) #se llama a la funcion auto fill sabiendo que se modificó solo esa celda.
        if type(item_modificado)==int: #Esto pasa cuando se modifica una capa entera, ya sea por agregarla o sustituirla.
            for j in range(len(self.parametros_ordenados_de_tabla)):#en ese caso se llama a la funcion autofill_celda_particular para cada item de esa capa.
                if (self.mainWind.muro_armado.item(item_modificado,self.parametros_ordenados_de_tabla[j]).text()==u''):#si la celda esta vacia:
                    self.autofill_celda_particular(item_modificado,self.parametros_ordenados_de_tabla[j])#intento hacer auto fill de la celda vacia
                #Si la celda no esta vacia, no llamo a autofill pasandole la celda, esto es porque puede pasar que el usuario quiera poner algo incoherente como el caso de los ceramicos huecos, donde espesor*densidad no es igual a masa.
    def autofill_celda_particular(self,i,j):
        #Funcion que a partir de la modificacion de una celda particular, completa/actualiza lo que sea necesario del cerramiento.
        #Basicamente intenta completar la celda modificada (en caso que esa celda no sea valida, como ser texto)
        #Si la celda que se modifico (la pasada en i,j) afecta el valor de otra celda, las mismas se autocompletan. 
        #Las prioridades aca definidas fueron definidas por el grupo de Ingenieros. Algunos paramoetros como espesor y densidad nunca se autocompletan para evitar loops de autofill
        parametros_flotantes = []#variable donde cargo en forma temporal las varibles en el orden definido en parametros_ordenados_de_tabla.
        for indice in self.parametros_ordenados_de_tabla:
            try:
                parametros_flotantes.append(float(self.mainWind.muro_armado.item(i,indice).data(Qt.DisplayRole)))
            except:
                parametros_flotantes.append(None)
        #Pongo con nombres mnemotecnicos los parametros para poder operar con ellos. Notar que todos son float si es posible o, None en caso contrario.
        try:
            espesor=parametros_flotantes[0]/1000 # porque el parametro ahora esta en milimetros. Esto fue un cambio del grupo de Arquitectos sobre la marcha.
        except:
            espesor=None
        densidad=parametros_flotantes[1]
        masa=parametros_flotantes[2]
        conductividad=parametros_flotantes[3]
        resistenciatermica=parametros_flotantes[4]
        permeabilidad=parametros_flotantes[5]
        factordevaporagua=parametros_flotantes[6]
        resistenciavapor=parametros_flotantes[7]
        sd =parametros_flotantes[8]
        calor_especifico=parametros_flotantes[9]
        cap_termica_media =parametros_flotantes[10]
        permeancia_vapo_agua=parametros_flotantes[11]
        permeabilidaddelaire=198e-12
        
        #En los siguientes titulos, se ejecuta el codigo correspondiente segun que parametro es el que se modifico          
        #Espesor
        if j == self.parametros_ordenados_de_tabla[0]:
           if espesor==None:
               pass
           else:
               try:
                   masa=densidad*espesor
               except:
                   pass
               try:
                   densidad=masa/espesor
               except:
                   pass
               try:
                   resistenciatermica=espesor/conductividad
               except:
                   pass
               try:
                   cap_termica_media=calor_especifico*masa/1000
               except:
                   pass
               if (sd==None):
                   try:
                       resistenciavapor=espesor/permeabilidad
                       permeancia_vapo_agua=1/resistenciavapor
                   except:
                       pass
                   try:
                       permeabilidad=espesor/resistenciavapor
                   except:
                       pass
        #Densidad
        if j == self.parametros_ordenados_de_tabla[1]:
           if densidad==None:
               try:
                   densidad=masa/espesor
               except:
                   pass
           else:
               try:
                   masa=densidad*espesor
               except:
                   pass
               try:
                   cap_termica_media=calor_especifico*masa/1000
               except:
                   pass
        #Masa
        if j == self.parametros_ordenados_de_tabla[2]:
           if masa==None:
               try:
                   masa=densidad*espesor
               except:
                   pass
           else:
               try:
                   densidad=masa/espesor
               except:
                   pass
               try:
                   cap_termica_media=calor_especifico*masa/1000
               except:
                   pass
        #Conductividad
        if j == self.parametros_ordenados_de_tabla[3]:
           if conductividad==None:
               conductividad=u''
           else:
               try:
                   resistenciatermica=espesor/conductividad
               except:
                   pass
        #Resistenciatermica
        if j == self.parametros_ordenados_de_tabla[4]:
           if resistenciatermica==None:
               try:
                   resistenciatermica=espesor/conductividad
               except:
                   pass
           else:
               conductividad=u''
               try:
                   conductividad=espesor/resistenciatermica*(conductividad/conductividad) #si no hay condictividad no la calculo
               except:
                   pass
        #Permeabilidad
        if j == self.parametros_ordenados_de_tabla[5]:
           if permeabilidad==None:
               try:
                   permeabilidad=espesor/resistenciavapor
               except:
                   pass
               try:
                   permeabilidad=permeabilidaddelaire/factordevaporagua
               except:
                   pass
           else:
               sd=u'' #Si hay permeabilidad no puede haber Sd ya que seria incompatible.
               try:
                   resistenciavapor=espesor/permeabilidad
                   permeancia_vapo_agua=1/resistenciavapor
               except:
                   pass
               try:
                   factordevaporagua=permeabilidaddelaire/permeabilidad
               except:
                   pass
        #Factordevapordeagua
        if j == self.parametros_ordenados_de_tabla[6]:
           if factordevaporagua==None:
               try:
                   factordevaporagua=permeabilidaddelaire/permeabilidad
               except:
                   pass
           else:
               sd=u'' #Si hay factordevaporagua no puede haber Sd ya que seria incompatible.
               try:
                   permeabilidad=permeabilidaddelaire/factordevaporagua
               except:
                   pass
               try:
                   resistenciavapor=espesor/permeabilidad
                   permeancia_vapo_agua=1/resistenciavapor
               except:
                   pass
        #ResistenciadeVapor
        if j == self.parametros_ordenados_de_tabla[7]:
           if resistenciavapor==None:
               try:
                   resistenciavapor=espesor/permeabilidad
                   permeancia_vapo_agua=1/resistenciavapor
               except:
                   pass
               try:
                   resistenciavapor=sd/permeabilidaddelaire
                   permeancia_vapo_agua=1/resistenciavapor
               except:
                   pass
           else:
               sd=u'' #Si hay ResistenciadeVapor no puede haber Sd ya que seria incompatible.              
               try:
                   permeancia_vapo_agua=1/resistenciavapor
               except:
                   pass
               try:
                   permeabilidad=espesor/resistenciavapor
               except:
                   pass
               try:
                   factordevaporagua=permeabilidaddelaire/permeabilidad
               except:
                   pass
        #sd        
        if j == self.parametros_ordenados_de_tabla[8]:
            if (sd==None):
                pass
            else:
                #Al haber Sd, tengo que borrar permeabilidad y vapor de agua porque esos parametros ya no son utilizados en el calculo.
                permeabilidad=u'' 
                factordevaporagua=u''
                try:
                   resistenciavapor=sd/permeabilidaddelaire
                   permeancia_vapo_agua=1/resistenciavapor
                except:
                   pass             
        #calor_especifico
        if j == self.parametros_ordenados_de_tabla[9]:
            if calor_especifico==None:
               try:
                   calor_especifico=cap_termica_media*1000/masa
               except:
                   pass
            else:
               try:
                   cap_termica_media=masa*calor_especifico/1000
               except:
                   pass            
        #cap_termica_media
        if j == self.parametros_ordenados_de_tabla[10]:
            if cap_termica_media==None:
               try:
                   cap_termica_media=calor_especifico*masa/1000
               except:
                   pass
            else:
               try:
                   calor_especifico=cap_termica_media*1000/masa
               except:
                   pass
        #permeancia_vapo_agua        
        if j == self.parametros_ordenados_de_tabla[11]:
            if permeancia_vapo_agua==None:
               try:
                   permeancia_vapo_agua=1/resistenciavapor
               except:
                   pass
            else:
               sd=u'' #Si hay permeancia_vapo_agua no puede haber Sd ya que seria incompatible.              
               try:
                   resistenciavapor=1/permeancia_vapo_agua
               except:
                   pass
               try:
                   permeabilidad=espesor*permeancia_vapo_agua
               except:
                   pass
               try:
                   factordevaporagua=permeabilidaddelaire/permeabilidad
               except:
                   pass
        #Los parametros con nombres mnemotecnicos vuelven a cargarse en los parametros_flotantes
        parametros_flotantes[1]=densidad
        parametros_flotantes[2]=masa
        parametros_flotantes[3]=conductividad
        parametros_flotantes[4]=resistenciatermica
        parametros_flotantes[5]=permeabilidad
        parametros_flotantes[6]=factordevaporagua
        parametros_flotantes[7]=resistenciavapor
        parametros_flotantes[8]=sd
        parametros_flotantes[9]=calor_especifico
        parametros_flotantes[10]=cap_termica_media
        parametros_flotantes[11]=permeancia_vapo_agua
        #Luego estos parametros_flotantes se cargan nuevamente en la tabla, finalizando asi el autofill
        for indice in range(len(parametros_flotantes)):
            if not(parametros_flotantes[indice]==None):
                aux=parametros_flotantes[indice]
                itemacargar=QTableWidgetItem()
                itemacargar.setData(Qt.DisplayRole,aux)
                self.mainWind.muro_armado.setItem(i,self.parametros_ordenados_de_tabla[indice],itemacargar)    
                   
    def pinto_muro(self):
        #funcion que "pinta" el muro segun si las capas son correctas y si los materiales estan en la base de datos o no
        #Todos los chequeos relativos a si el muro es valido o no, se hacen aca.
        #Antes de estos chequeos se corrio un autofill pero no aca, eso lo hace la funcion muro_modificado
        self.muro_valido=True #Todo muro es valido hasta que se demuestre lo contrario
        self.capas_malas = [] #ninguna columna es mala hasta que se demuestre lo contrario
        self.camara_MV=[] #El muro no tiene camaras de aire muy ventiladas hasta que las mismas se encuentren.
        self.camara_NMV=[] #El muro no tiene camaras de aire no muy ventiladas hasta que las mismas se encuentren.
        #Defino tipo de letra que se le va a asignar al texto en las capas que pertenecen a la base de datos original (BDO)        
        texto_negrita = QFont() 
        texto_negrita.setBold(True)
        #Defino tipo de letra que se le va a asignar al texto en las capas que no pertenecen a BDO
        texto_comun = QFont()
        texto_comun.setBold(False)
        #Defino tipo de letra que se le va a asignar al texto en las capas que no son validas.
        texto_itali =QFont()
        texto_itali.setItalic(True)
        filas = self.mainWind.muro_armado.rowCount() #cantidad de filas en la planilla
        columnas= self.mainWind.muro_armado.columnCount() #cantidad de columnas en la planilla
        if filas==0:
            self.muro_valido=False #si el muro esta vacio, entonces no es valido para nada.
        for i in range(filas): #Se recorren las filas para determinar el estado de la misma y relizar el cambio de formato de texto correspondiente.
            #Tratamiento especial para la capa de aire muy ventilada. Se bloquean todos los parametros menos los pimeros dos (nombre y espesor)
            try:
                indices_a_bloquear=range(2,columnas)
                for j in indices_a_bloquear:
                    item= QTableWidgetItem()
                    item.setData(Qt.DisplayRole,self.mainWind.muro_armado.item(i,j).data(Qt.DisplayRole))
                    if ((self.mainWind.muro_armado.item(i,0).text()==u'Cámara de aire muy ventilada - vertical')|(self.mainWind.muro_armado.item(i,0).text()==u'Cámara de aire muy ventilada - horizontal')):
                        item.setFlags(item.flags() & ~(Qt.ItemIsEditable))
                    else:  
                        pass
                    self.mainWind.muro_armado.setItem(i, j, item)                        
            except:
                pass    
            #Se verifica si la capa esta en la lista de materiales original (BDO)
            try:
                capa= [self.mainWind.muro_armado.item(i,j).text() for j in self.hubicacion_columnas_a_mostrar_muro_from_preview] #Genero un array con los elementos del material
                [estaono, esigual] = self.mainWind.lista_materiales_obj.chequeo_si_material_existe(self.mainWind.lista_materiales_obj.materiales_originales_dataframe,capa) #se ejecuta una funcion definida en otra clase (listas_materiales) que establece si el material con ese nombre y parametros esta o no en el databrame que tamien se le pasa como parametro. En este caso le paso el dataframe BDO
                if esigual: #Si pertenece a BDO
                    for j in range(columnas-1):
                        self.mainWind.muro_armado.item(i,j).setFont(texto_negrita)#se establece el tipo de letra correspondiente
                    dato = QTableWidgetItem(u'BDO')                                        
                    self.mainWind.muro_armado.setItem(i,columnas-1,dato) #se carga en la columna observaciones el texto que indica que el material pertenece a BDO
                else: #Si el material no pertenece a la BDO
                    for j in range(columnas-1):
                        self.mainWind.muro_armado.item(i,j).setFont(texto_comun) #se establece el tipo de letra correspondiente
                    dato = QTableWidgetItem(u'')                                        
                    self.mainWind.muro_armado.setItem(i,columnas-1,dato)#se borra de la columna observaciones el texto que indica que el material pertenece a BDO
            except: #Si cualquiera de estas cosas no se puede realizar, entonces el muro no es valido.
                self.muro_valido=False   
            #Ahora se "pintan" los materiales que les falta algun parametro o el que tienen no es valido.
            capa_valida=True # la capa es valida hasta que se demuestre lo contrario
            for j in self.parametros_ordenados_de_tabla : #para cada item de la tabla pregunto
                if not((j==self.parametros_ordenados_de_tabla[3])|(j==self.parametros_ordenados_de_tabla[8])|(j==self.parametros_ordenados_de_tabla[9])|(j==self.parametros_ordenados_de_tabla[5])|(j==self.parametros_ordenados_de_tabla[6])|(j==self.parametros_ordenados_de_tabla[10])): #no miro todas las columnas, por el tema que puede estar sd o mu y ro, con que este Z alcanza.
                    try:
                        aux=float(self.mainWind.muro_armado.item(i,j).text()) #intento convertirlo a float
                        if (isnan(aux)):#si aux is not a number
                            capa_valida= False #la capa no es valida
                    except:#si ni siquiera puedo hacer lo anterior
                        capa_valida= False #la capa no es valida
            #Si es una camara de aire muy ventilada no corre la misma logica. para determinar si es valida o no. Dado que esto fue modificado por el grupo de Arquitectos sobre la marcha, se soluciono con lo siguiente, que sobre escribe lo anterior para el caso de una camara de aire muy ventilada
            if ((self.mainWind.muro_armado.item(i,0).text()==u'Cámara de aire muy ventilada - horizontal')|(self.mainWind.muro_armado.item(i,0).text()==u'Cámara de aire muy ventilada - vertical')):            
                capa_valida=True #esta capa es valida si tiene espesor
                try:
                    float(self.mainWind.muro_armado.item(i,1).text())
                    self.camara_MV.append(i)
                except:
                    capa_valida=False
            #Si es una camara de aire poco ventilada tampoco sigue la misma logica. Dado que esto fue modificado por el grupo de Arquitectos sobre la marcha, se soluciono con lo siguiente, que sobre escribe lo anterior para el caso de una camara de aire no muy ventilada
            if ((self.mainWind.muro_armado.item(i,0).text()==u'Cámara de aire no ventilada con superficies de alta emisividad (no metálica) - vertical (15 mm o más)')|(self.mainWind.muro_armado.item(i,0).text()==u'Cámara de aire no ventilada con superficies de alta emisividad (no metálica) - horizontal (15 mm o más)')|(self.mainWind.muro_armado.item(i,0).text()==u'Ligeramente ventilada - horizontal (15 mm o más)')|(self.mainWind.muro_armado.item(i,0).text()==u'Ligeramente ventilada - vertical (15 mm o más)')):                        
                self.camara_NMV.append(i)
                capa_valida=True # la capa es valida hasta que se demuestre lo contrario
                for j in self.parametros_ordenados_de_tabla :
                    if not((j==self.parametros_ordenados_de_tabla[1])|(j==self.parametros_ordenados_de_tabla[2])|(j==self.parametros_ordenados_de_tabla[3])|(j==self.parametros_ordenados_de_tabla[8])|(j==self.parametros_ordenados_de_tabla[9])|(j==self.parametros_ordenados_de_tabla[5])|(j==self.parametros_ordenados_de_tabla[6])|(j==self.parametros_ordenados_de_tabla[10])): #no miro todas las columnas, por el tema que puede estar sd o mu y ro, con que este Z alcanza.
                        try:
                            aux=float(self.mainWind.muro_armado.item(i,j).text())
                            if (isnan(aux)):
                                capa_valida= False
                        except:
                            capa_valida= False
            if not(capa_valida): #si la capa no es valida
                self.capas_malas.append(i) #se guarda el indice de la capa no valida
            for j in range(columnas-1):#se recorre la capa
                    if not(capa_valida): #si la capa no es valida
                        self.muro_valido=False #el muro tampoco lo es
                        try:
                            self.mainWind.muro_armado.item(i,j).setFont(texto_itali) ##se establece el tipo de letra correspondiente
                        except:
                            pass
            #A pedido de arquitectura pinto la columna espesor        
            self.mainWind.muro_armado.item(i,1).setBackground(QColor(102,153,102,255))
        
    def formato_numeros(self, entrada):
        #funcion que recibe un parametro que va a ser mostrado en el muro y devuelvo el mismo con un formato adecuado para mostrarlo. 
        #Modificando esta funcion se altera solo la forma en la que se muestran los parametros NO el valor del mismo.
        try:
            salida=float(entrada)
            if (abs(salida)>9999)|(abs(salida)<0.1):#si el numero a mostrar es "demasiado grande" o "pequeño" se opta por notacion ingenieril con dos numeros despues de la coma
                salida="{0:.2E}".format(salida)
            else:
                salida=round(salida, 2)#Si el nomero no es ni "muy grande" ni "muy chico" se redondea a dos numeros despues de la coma (se redondea solo lo que se muestra!! no el valor propiamente dicho)
        except:
            salida=entrada
        return unicode(salida) #se devuelve en formato unicode ya que esto es lo que luego se muestra, es texto.
        
