# -*- coding: utf-8 -*-
"""
Created on Tue Oct 25 16:51:32 2016

@author: fveirano
"""

from PyQt4.QtGui import QMessageBox
from PyQt4.QtGui import QPushButton

class manejoParametros():
    
    def __init__(self,mainWind): 
        
        # Parametros por defecto
        self.humedadExt = '85'        
        self.humedadInt = '80'        
        self.resistExt= '0.04' 
        self.resistIntCH='0.1'
        self.resistIntCV='0.13'
        self.resistIntCond='0.25'
        self.tempInt='18.0'
        
        self.tempZona1CH='10'
        self.tempZona2CH='9.3'
        self.tempZona3CH='8.7'

        
        self.tempZona1CV='12'
        self.tempZona2CV='11.3'
        self.tempZona3CV='10.7'
       
        # Seteo los parametros en la gui
        mainWind.humedadExt.setText(self.humedadExt)
        mainWind.humedadInt.setText(self.humedadInt)
        mainWind.resistExt.setText(self.resistExt)
        mainWind.resistInt.setText(self.resistIntCH)
        mainWind.resistIntCond.setText(self.resistIntCond)
        mainWind.tempExt.setText(self.tempZona1CH)
        mainWind.tempInt.setText(self.tempInt)  
        mainWind.cerramientoBox.activated.connect(self.cambiarCerramiento)
        mainWind.zonasBox.activated.connect(self.cambiarZona)
        mainWind.rstParam.clicked.connect(self.paramNorma)       
        self.mainWind = mainWind         



    def verificarCondBaseNorma(self):
    # Funcion que verifica si alguno de los parametros fue modificado para indicar que se esta fuera de la norma. Se indica con un texto en 
    # la interfaz gráfica    
        self.verificoParametro(self.mainWind.humedadExt.text(),u'Humedad Exterior',u'La humedad debe ser un valor númerico entre 0 y 100.')
        self.verificoParametro(self.mainWind.humedadInt.text(),u'Humedad Interior',u'La humedad debe ser un valor númerico entre 0 y 100.')
        self.verificoParametro(self.mainWind.resistExt.text(),u'Resistencia Térmica Exterior',u'La resistencia debe ser un valor númerico.')
        self.verificoParametro(self.mainWind.resistInt.text(),u'Resistencia Térmica Interior',u'La resistencia debe ser un valor númerico.')
        self.verificoParametro(self.mainWind.resistIntCond.text(),u'Resistencia Térmica Interior',u'La resistencia debe ser un valor númerico.')
        self.verificoParametro(self.mainWind.tempExt.text(),u'Temperatura Exterior',u'La temperatura debe ser un valor númerico.')
        self.verificoParametro(self.mainWind.tempInt.text(),u'Temperatura Interior',u'La temperatura debe ser un valor númerico.')           
        
        index=self.mainWind.cerramientoBox.currentIndex()
        indexzona=self.mainWind.zonasBox.currentIndex()
        if index==0:
            var =self.mainWind.humedadExt.text()==self.humedadExt and self.mainWind.humedadInt.text()==self.humedadInt and self.mainWind.resistExt.text()==self.resistExt and self.mainWind.resistInt.text()==self.resistIntCH  and self.mainWind.tempInt.text()==self.tempInt and self.mainWind.resistIntCond.text()==self.resistIntCond
            if indexzona == 0:
                if  (var and self.mainWind.tempExt.text()==self.tempZona1CH): norma=True 
                else: norma= False
            elif indexzona== 1:
                if  var and self.mainWind.tempExt.text()==self.tempZona2CH : norma= True 
                else: norma= False
            else: 
                if  var and self.mainWind.tempExt.text()==self.tempZona3CH : norma= True 
                else: norma= False
            
        else: 
            var =self.mainWind.humedadExt.text()==self.humedadExt and self.mainWind.humedadInt.text()==self.humedadInt and self.mainWind.resistExt.text()==self.resistExt and self.mainWind.resistInt.text()==self.resistIntCV and self.mainWind.tempInt.text()==self.tempInt and self.mainWind.resistIntCond.text()==self.resistIntCond
            if indexzona == 0:
                if  var and self.mainWind.tempExt.text()==self.tempZona1CV : norma= True 
                else: norma= False
            elif indexzona== 1:
                if  var and self.mainWind.tempExt.text()==self.tempZona2CV : norma= True 
                else: norma= False
            else: 
                if  var and self.mainWind.tempExt.text()==self.tempZona3CV : norma= True 
                else: norma= False
                
        # Se setea el texto que indica si se esta bajo norma o no.
        if norma: self.mainWind.norma.setText(u'Bajo Norma')
        else: self.mainWind.norma.setText(u'Fuera de Norma')         
       
    
    def paramNorma(self):
    # Funcion que reinicia todos los parámetros a la norma.     
        index=self.mainWind.cerramientoBox.currentIndex()
        indexzona=self.mainWind.zonasBox.currentIndex()
        self.mainWind.tempInt.setText(self.tempInt)
        self.mainWind.resistIntCond.setText(self.resistIntCond)
        self.mainWind.humedadExt.setText(self.humedadExt)
        self.mainWind.humedadInt.setText(self.humedadInt)
        self.mainWind.resistExt.setText(self.resistExt)
        if index==0:
            self.mainWind.resistInt.setText(self.resistIntCH)  
            if indexzona == 0:
                 self.mainWind.tempExt.setText(self.tempZona1CH)
            elif indexzona== 1:
                 self.mainWind.tempExt.setText(self.tempZona2CH)
            else: 
                 self.mainWind.tempExt.setText(self.tempZona3CH)
        else: 
            self.mainWind.resistInt.setText(self.resistIntCV)
            if indexzona == 0:
                 self.mainWind.tempExt.setText(self.tempZona1CV)
            elif indexzona== 1:
                 self.mainWind.tempExt.setText(self.tempZona2CV)
            else: 
                 self.mainWind.tempExt.setText(self.tempZona3CV)
            
         
    def cambiarCerramiento(self):
    # Funcion que cambia los parametros de acuerdo al cerramiento seleccionado. Es llamada 
    # cuando se detecta un cambio en el combo.
        index=self.mainWind.cerramientoBox.currentIndex()
        indexzona=self.mainWind.zonasBox.currentIndex()
        if index==0:
            self.mainWind.resistInt.setText(self.resistIntCH)
            if indexzona == 0:
                 self.mainWind.tempExt.setText(self.tempZona1CH)
            elif indexzona== 1:
                 self.mainWind.tempExt.setText(self.tempZona2CH)
            elif indexzona==2: 
                 self.mainWind.tempExt.setText(self.tempZona3CH)            
        else: 
            self.mainWind.resistInt.setText(self.resistIntCV)
            if indexzona == 0:
                 self.mainWind.tempExt.setText(self.tempZona1CV)
            elif indexzona== 1:
                 self.mainWind.tempExt.setText(self.tempZona2CV)
            elif indexzona==2: 
                 self.mainWind.tempExt.setText(self.tempZona3CV)



    def cambiarZona(self):
    # Funcion que cambia los parametros de acuerdo a la zona seleccionado. Es llamada 
    # cuando se detecta un cambio en el combo.
        index=self.mainWind.cerramientoBox.currentIndex()
        indexzona=self.mainWind.zonasBox.currentIndex()
        if index==0:   
            if indexzona == 0:
                 self.mainWind.tempExt.setText(self.tempZona1CH)
            elif indexzona== 1:
                 self.mainWind.tempExt.setText(self.tempZona2CH)
            elif indexzona==2: 
                 self.mainWind.tempExt.setText(self.tempZona3CH)

        else:     
            if indexzona == 0:
                 self.mainWind.tempExt.setText(self.tempZona1CV)
            elif indexzona== 1:
                 self.mainWind.tempExt.setText(self.tempZona2CV)
            elif indexzona==2: 
                 self.mainWind.tempExt.setText(self.tempZona3CV)

              

            
    def leoParametros(self,mainWind):
    # Funcion que es llamada antes de realizar los calculos. Lee cada uno de los parametros y
    #  los pasa a float.     
        self.verificarCondBaseNorma()        
        mainWind.calcObj.humedadExt = float(mainWind.humedadExt.text())
        mainWind.calcObj.humedadInt = float(mainWind.humedadInt.text())
        mainWind.calcObj.resistExt = float(mainWind.resistExt.text())
        mainWind.calcObj.resistInt = float(mainWind.resistInt.text())
        mainWind.calcObj.resistIntCond = float(mainWind.resistIntCond.text())
        mainWind.calcObj.tempExt = float(mainWind.tempExt.text())
        mainWind.calcObj.tempInt = float(mainWind.tempInt.text())
                
        
        
    def verificoParametro(self, parametroValor,parametroNombre,textodetallado):  
    # FUnción que verifica si un parametro escrito tiene el formato necesario. De lo contrario depliega un 
    # mensaje de error.                    
        if (parametroValor==u'None')|(parametroValor==u'nan')|(parametroValor==u''):
            self.errorParametroInvalido(parametroNombre,parametroValor,textodetallado)
            self.cambiarCerramiento()

        try:
            
            if (parametroNombre==u'Humedad Exterior')|(parametroNombre==u'Humedad Interior'):
                if (float(parametroValor)>100)|(float(parametroValor)<0):
                    self.errorParametroInvalido(parametroNombre,parametroValor,textodetallado)
                    self.paramNorma() 
        except ValueError:
            #Si no puedo hacer la conversion es porque la persona puso cualquier cosa.
            #En ese caso, llama a la funcion errorParametroInvalido y le paso el nombre del parametro y el valor incorrecto
            self.errorParametroInvalido(parametroNombre,parametroValor,textodetallado)
            self.paramNorma()
   

    def errorParametroInvalido(self,parametro,valorIncorrecto,textodetallado):
        #Funcion que se ejecuta para avisarle al usuario que "valorIncorrecto" en "parametro" no es valido
        msg = QMessageBox() #genero la ventana
        msg.setWindowTitle(u'Error')
        msg.setIcon(QMessageBox.Warning) #le pongo el signo de warning (puedo poner alerta y pregunta)
        msg.setText(textodetallado) # mensaje principal del error    
        msg.addButton(QPushButton('Aceptar'), QMessageBox.AcceptRole)
        

        msg.exec_() # No se bien que hace pero es necesario     